package com.appsallglobal.statuswalls;






import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import com.airbnb.lottie.LottieAnimationView;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.bumptech.glide.Glide;
import com.denzcoskun.imageslider.ImageSlider;
import com.denzcoskun.imageslider.constants.ScaleTypes;
import com.denzcoskun.imageslider.models.SlideModel;
import com.squareup.picasso.Picasso;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;


public class HomeFragment extends Fragment {
    public  static  String myUrl = null;
HashMap<String,String> hashMap;
ArrayList<HashMap<String,String>> arrayList =  new ArrayList<>();
ArrayList<HashMap<String,String>> arrayListTop = new ArrayList<>();
ArrayList<HashMap<String,String>> arrayListWallpeper = new ArrayList<>();
public  static  int homequotesCount = 0;
    public static Bitmap bitmap1= null;
    public static Bitmap bitmap = null;

    int tobCount =4;
int wallCont = 3;
RecyclerView recyclerViewTop,gridViewWalpepeer;
ProgressBar progressBarHome;
GridView gridView;
TextView textView1,textView2;
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {


        View homeView = inflater.inflate(R.layout.fragment_home, container, false);
if (homeView==null){

    Toast.makeText(getContext(), "Can not load", Toast.LENGTH_SHORT).show();

} else {
    gridView = homeView.findViewById(R.id.gridView_home);
progressBarHome= homeView.findViewById(R.id.progresbarHome);
    recyclerViewTop = homeView.findViewById(R.id.recyclerviewTob);
    gridViewWalpepeer=homeView.findViewById(R.id.gridViewWalperer);
textView1 = homeView.findViewById(R.id.text1);
    textView2 = homeView.findViewById(R.id.text2);


    serverHome();
    ImageSlider imageSlider;
walpServer();
serverTop();




    imageSlider =homeView.findViewById(R.id.image_slider);


    ArrayList<SlideModel> imageList = new ArrayList<>();


    imageList.add(new SlideModel("https://appsallglabal.com/Statuswall/Image%20silder%20/quotesI.png", ScaleTypes.CENTER_CROP));
    imageList.add(new SlideModel("https://appsallglabal.com/Statuswall/Image%20silder%20/repet.png",ScaleTypes.CENTER_CROP));
    imageList.add(new SlideModel("https://appsallglabal.com/Statuswall/Top%20Status%20and%20quotes/Image/as2.jpg",ScaleTypes.CENTER_CROP));
    imageList.add(new SlideModel("https://appsallglabal.com/Statuswall/Image%20silder%20/catandview.png",ScaleTypes.CENTER_CROP));
    imageSlider.setImageList(imageList);


}





        return  homeView;
    }

    private void walpServer() {


        String wUrl = "https://appsallglabal.com/Statuswall/As%20Wallpaper/wallpaper.json";

        JsonArrayRequest jsonArrayRequest = new JsonArrayRequest(Request.Method.GET, wUrl, null, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {

                textView2.setVisibility(View.VISIBLE);

           for ( int b = 0;b<response.length();b++){

               try {
                   JSONObject jsonObject = response.getJSONObject(b);


                   String wpLink = jsonObject.getString("wp");
                   hashMap = new HashMap<>();
                   hashMap.put("link",wpLink);
                   arrayListWallpeper.add(hashMap);






                   wallAdapter wallAdapter =  new wallAdapter();
                   // RecyclerView-এ Adapter সেট করি
                   gridViewWalpepeer.setAdapter(wallAdapter);

                   // GridLayoutManager তৈরি করি এবং কলামের সংখ্যা নির্ধারণ করি
                   int numberOfColumns = 3; // উদাহরণস্বরূপ ৩টি কলাম
                   GridLayoutManager gridLayoutManager = new GridLayoutManager(getActivity(), numberOfColumns);

                   // RecyclerView-এ LayoutManager সেট করি
                   gridViewWalpepeer.setLayoutManager(gridLayoutManager);








               } catch (JSONException e) {
                   throw new RuntimeException(e);
               }

           }


            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Toast.makeText(getContext(), ""+error.getMessage(), Toast.LENGTH_SHORT).show();

            }
        });

        // Initialize the request queue
        RequestQueue queue = Volley.newRequestQueue(getContext());

// Add the request to the queue
        queue.add(jsonArrayRequest);

    }

    private void serverTop() {


String url = "https://appsallglabal.com/Statuswall/Top%20Status%20and%20quotes/image.json";


        JsonArrayRequest jsonArrayRequest = new JsonArrayRequest(Request.Method.GET, url, null, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {
textView1.setVisibility(View.VISIBLE);
                for (int b = 0;b<response.length();b++) {

                    try {
                        JSONObject jsonObject = response.getJSONObject(b);



                        String item = jsonObject.getString("sq");
                        String url = jsonObject.getString("url");

                        hashMap = new HashMap<>();
                        hashMap.put("item",item);
                        hashMap.put("url",url);
arrayListTop.add(hashMap);
                        tobAdapter tobAdapter = new tobAdapter();
                        recyclerViewTop.setAdapter(tobAdapter);
                        recyclerViewTop.setLayoutManager(new LinearLayoutManager(getActivity(), LinearLayoutManager.HORIZONTAL, false));

                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }


                }



            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Toast.makeText(getContext(), "Something is wrong", Toast.LENGTH_SHORT).show();

            }
        });
// Initialize the request queue
        RequestQueue queue = Volley.newRequestQueue(getContext());

// Add the request to the queue
        queue.add(jsonArrayRequest);


    }

    private void serverHome() {

        String homUrl = "https://appsallglabal.com/Statuswall/Home%20page%20Catagory/homepages.json/catHome.json";


        JsonArrayRequest jsonArrayRequest = new JsonArrayRequest(Request.Method.GET, homUrl, null, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {
progressBarHome.setVisibility(View.GONE);
                for (int b = 0;b<response.length();b++) {

                    try {
                        JSONObject jsonObject = response.getJSONObject(b);



                       String catImageg = jsonObject.getString("catImage");
                        String catTitleg = jsonObject.getString("catTitle");

                        hashMap = new HashMap<>();
                        hashMap.put("ct",catTitleg);
                        hashMap.put("ci",catImageg);
                        arrayList.add(hashMap);
                        homeAdapter homeAdapter =  new homeAdapter();
                        gridView.setAdapter(homeAdapter);


                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }


                }



            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                progressBarHome.setVisibility(View.GONE);
              //  Toast.makeText(getContext(), "Something is wrong", Toast.LENGTH_SHORT).show();
                Toast.makeText(getActivity(), ""+error.getMessage(), Toast.LENGTH_SHORT).show();
            }
        });
// Initialize the request queue
        RequestQueue queue = Volley.newRequestQueue(getContext());

// Add the request to the queue
        queue.add(jsonArrayRequest);
    }


    private  class  homeAdapter extends BaseAdapter {


        @Override
        public int getCount() {
            return arrayList.size();
        }

        @Override
        public Object getItem(int position) {
            return null;
        }

        @Override
        public long getItemId(int position) {
            return 0;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {

LayoutInflater layoutInflater = (LayoutInflater) getActivity().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
 View homeItemview = layoutInflater.inflate(R.layout.home_item,parent,false);
HashMap<String,String> hashMap1 = arrayList.get(position);
String getImage = hashMap1.get("ci");
String getTitle = hashMap1.get("ct");
myUrl=getImage;
            ImageView imageView = homeItemview.findViewById(R.id.catImage);
            TextView textView = homeItemview.findViewById(R.id.catTitle);
            CardView cardView = homeItemview.findViewById(R.id.cardView_home);

            textView.setText(getTitle);


            Glide.with(requireContext()).load(getImage).placeholder(R.drawable.p1 ).into(imageView);


cardView.setOnClickListener(new View.OnClickListener() {
    @Override
    public void onClick(View v) {
        homequotesCount++;


        if (position==0){
            startActivity( new Intent(getActivity(), StatusCatagorActivityy.class));
            if (homequotesCount<3){

              // showHomepageADD();

            }
        } else if (position==1) {




startActivity( new Intent(getActivity(), QuotesActivity.class));

            if (homequotesCount<3){

               showHomepageADD(getActivity());

            }




        }

    }
});


            return homeItemview;
        }
    }


    private  class  tobAdapter extends  RecyclerView.Adapter{

        int sandq_item = 0;int othaer_item = 1;

        private    class  sandqViewHolder extends   RecyclerView.ViewHolder{


ImageView imageView;
CardView cardViewRead ;

            public sandqViewHolder(@NonNull View itemView) {
                super(itemView);
                imageView = itemView.findViewById(R.id.imageViewTop);
                cardViewRead = itemView.findViewById(R.id.carviewReadd);
            }
        }


        private  class  othaersViewHolder extends  RecyclerView.ViewHolder{


            public othaersViewHolder(@NonNull View itemView) {
                super(itemView);
            }
        }









        @NonNull
        @Override
        public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {


            LayoutInflater layoutInflater = getActivity().getLayoutInflater();
            if ( viewType==sandq_item){
                View sqView = layoutInflater.inflate(R.layout.sandq_item,parent,false);

return  new sandqViewHolder(sqView);
            }


            return null;
        }

        @Override
        public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {

            sandqViewHolder sandqViewHolder = (tobAdapter.sandqViewHolder) holder;

if (getItemViewType(position)==sandq_item)     {



    HashMap<String,String> hashMap1 =arrayListTop.get(position);
    String url = hashMap1.get("url");



    Glide.with(requireContext()).load(url).placeholder(R.drawable.p1).into(sandqViewHolder.imageView);
sandqViewHolder.cardViewRead.setOnClickListener(new View.OnClickListener() {
    @Override
    public void onClick(View v) {



        Intent intent = new Intent(requireContext(),MainActivity2.class);
        intent.putExtra("image",url);
        startActivity(intent);





tobCount++;
        if (tobCount%5==0){
           showHomepageADD(getActivity());

        }
        }




});






}




        }

        @Override
        public int getItemCount() {
            return arrayListTop.size();
        }


        @Override
        public int getItemViewType(int position) {

HashMap<String,String> hashMap1 = arrayListTop.get(position);
String item = hashMap1.get("item");
if (item.contains("sq")) return  sandq_item;
else  return  othaer_item;

        }
    }


private  class wallAdapter extends  RecyclerView.Adapter<wallAdapter.wallHolder>{

    @NonNull
    @Override
    public wallHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        LayoutInflater layoutInflater = getActivity().getLayoutInflater();
        View myWallView = layoutInflater.inflate(R.layout.wallpepar_item,parent,false);



        return new wallHolder(myWallView);
    }

    @Override
    public void onBindViewHolder(@NonNull wallHolder holder, int position) {
int a= position+1;
holder.textView.setText("Position "+a);


        HashMap<String,String> hashMap1 = arrayListWallpeper.get(position);

String linlW = hashMap1.get("link");


        Glide.with(requireContext()).load(linlW).placeholder(R.drawable.p1).into(holder.imageView);




holder.cardViewp.setOnClickListener(v->{
    wallCont++;
    Intent intent = new Intent(requireContext(),SeeWallapaperActivity.class);
    intent.putExtra("image",linlW);
    startActivity(intent);
    if (wallCont%4==0){

        showHomepageADD(getActivity());
    }


});

    }

    @Override
    public int getItemCount() {
        return arrayListWallpeper.size();
    }

    private  class  wallHolder extends  RecyclerView.ViewHolder{
CardView cardViewp ;
ImageView imageView;TextView textView;
           public wallHolder(@NonNull View itemView) {
               super(itemView);

               textView = itemView.findViewById(R.id.titileText);
imageView = itemView.findViewById(R.id.imagevIEWaLL);
cardViewp = itemView.findViewById(R.id.cardViewWallp);

           }
       }

}






    private void   showHomepageADD(Activity activity) {

        String url = "https://appsallglabal.com/Statuswall/Admob%20Ads%20Control/fullscreenads.php";
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url, new Response.Listener<String>() {
            @Override
            public void onResponse(String response) {

                if (response.contains("on")){

                    if (ManageServer.mInterstitialAd != null) {
                        ManageServer.mInterstitialAd.show(activity);
                    } else {
                        Log.d("TAG", "The interstitial ad wasn't ready yet.");
                    }

                }






            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });
        RequestQueue queue = Volley.newRequestQueue(getContext());

// Add the request to the queue
        queue.add(stringRequest);

    }










}