package com.appsallglobal.statuswalls;

import android.app.Activity;
import android.app.Application;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.gms.ads.AdError;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.FullScreenContentCallback;
import com.google.android.gms.ads.LoadAdError;
import com.google.android.gms.ads.MobileAds;
import com.google.android.gms.ads.interstitial.InterstitialAd;
import com.google.android.gms.ads.interstitial.InterstitialAdLoadCallback;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;

public class ManageServer extends Application {
    public  static InterstitialAd mInterstitialAd;
HashMap<String,String> hashMap;
public  static  ArrayList<HashMap<String,String>> arrayList = new ArrayList<>();
    public  static ArrayList<HashMap<String,String>> arrayListAttidute = new ArrayList<>();
    public  static ArrayList<HashMap<String,String>> arrayListBraekup = new ArrayList<>();
    public  static ArrayList<HashMap<String,String>> arrylistfriends = new ArrayList<>();
    public  static ArrayList<HashMap<String,String>> arraylistRelationship = new ArrayList<>();
    public  static ArrayList<HashMap<String,String>> arraylistsad = new ArrayList<>();
    public  static ArrayList<HashMap<String,String>> araylistStudy = new ArrayList<>();










    @Override
    public void onCreate() {
        super.onCreate();
      //  new Thread(
               // () -> {
                   // Initialize the Google Mobile Ads SDK on a background thread.
            //       MobileAds.initialize(this, initializationStatus -> {});
           //   })
             //   .start();



        attitude();breakup(); friends(); Relationship(); sad(); study();

catServer();
        loadFullScreenadd();


    }

    private void loadFullScreenadd() {


        AdRequest adRequest = new AdRequest.Builder().build();

        InterstitialAd.load(this,"ca-app-pub-9643062718954369/2866474206", adRequest,
                new InterstitialAdLoadCallback() {
                    @Override
                    public void onAdLoaded(@NonNull InterstitialAd interstitialAd) {
                        // The mInterstitialAd reference will be null until
                        // an ad is loaded.
                        mInterstitialAd = interstitialAd;

                        Log.i("TAG", "onAdLoaded");
                        callback();
                    }

                    @Override
                    public void onAdFailedToLoad(@NonNull LoadAdError loadAdError) {
                        // Handle the error
                        Log.d("TAG", loadAdError.toString());
                        mInterstitialAd = null;
                    }
                });



    }

    private void callback() {
        mInterstitialAd.setFullScreenContentCallback(new FullScreenContentCallback(){
            @Override
            public void onAdClicked() {
                // Called when a click is recorded for an ad.
                Log.d("tag", "Ad was clicked.");
            }

            @Override
            public void onAdDismissedFullScreenContent() {
                // Called when ad is dismissed.
                // Set the ad reference to null so you don't show the ad a second time.
                Log.d("tag", "Ad dismissed fullscreen content.");
                mInterstitialAd = null;
                loadFullScreenadd();
                Log.d("tag2", "Ad ready nt.");
            }

            @Override
            public void onAdFailedToShowFullScreenContent(AdError adError) {
                // Called when ad fails to show.
                Log.e("tag", "Ad failed to show fullscreen content.");
                mInterstitialAd = null;
            }

            @Override
            public void onAdImpression() {
                // Called when an impression is recorded for an ad.
                Log.d("tag", "Ad recorded an impression.");
            }

            @Override
            public void onAdShowedFullScreenContent() {
                // Called when ad is shown.
                Log.d("tag", "Ad showed fullscreen content.");
            }
        });
    }


    private void catServer() {

        String url = "https://appsallglabal.com/Statuswall/Status_Catagory%20Pages/caT_status.json";




        JsonArrayRequest jsonArrayRequest = new JsonArrayRequest(Request.Method.GET, url, null, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {

                for (int b = 0;b<response.length();b++) {

                    try {
                        JSONObject jsonObject = response.getJSONObject(b);




                        String titile = jsonObject.getString("cat_titile");
                        String image = jsonObject.getString("cat_photo");


                        hashMap = new HashMap<>();
                        hashMap.put("cat_titile",titile);
                        hashMap.put("cat_photo",image);
                        arrayList.add(hashMap);





                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }


                }



            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

                Toast.makeText(getApplicationContext(), "Server is down", Toast.LENGTH_SHORT).show();
            }
        });
// Initialize the request queue
        RequestQueue queue = Volley.newRequestQueue(getApplicationContext());

// Add the request to the queue
        queue.add(jsonArrayRequest);

    }


    public void  attitude(){









        String sadUrl = "https://appsallglabal.com/Statuswall/catgory%20php%20/attitude.php";

        JsonArrayRequest jsonArrayRequestSad = new JsonArrayRequest(Request.Method.GET, sadUrl, null, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {










                for (int s = 0; s < response.length(); s++) {
                    try {
                        JSONObject jsonObject = response.getJSONObject(s);

                        //StatusActivity.animationViewCatLoadss.setVisibility(View.GONE);
                        String con = jsonObject.getString("status");
                        String item = jsonObject.getString("item");

                        hashMap= new HashMap<>();
                        hashMap.put("item",item);
                        hashMap.put("status",con);
                        arrayListAttidute.add(hashMap);
                        Log.d("helo", "attidte Arraylist receved and send now status activity: ");




                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }



                }










            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });

        RequestQueue queue = Volley.newRequestQueue(ManageServer.this);  // Use requireActivity() in Fragment
        queue.add(jsonArrayRequestSad);


















    }

    public void  breakup(){









        String sadUrl = "https://appsallglabal.com/Statuswall/catgory%20php%20/breakup.php";

        JsonArrayRequest jsonArrayRequestSad = new JsonArrayRequest(Request.Method.GET, sadUrl, null, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {











                for (int s = 0; s < response.length(); s++) {
                    try {
                        JSONObject jsonObject = response.getJSONObject(s);

                        //StatusActivity.animationViewCatLoadss.setVisibility(View.GONE);
                        String con = jsonObject.getString("status");
                        String item = jsonObject.getString("item");

                        hashMap= new HashMap<>();
                        hashMap.put("item",item);
                        hashMap.put("status",con);
                        arrayListBraekup.add(hashMap);
                        Log.d("helo", "attidte Arraylist receved and send now status activity: ");




                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }



                }










            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });

        RequestQueue queue = Volley.newRequestQueue(ManageServer.this);  // Use requireActivity() in Fragment
        queue.add(jsonArrayRequestSad);


















    }

    public void  friends(){









        String sadUrl = "https://appsallglabal.com/Statuswall/catgory%20php%20/friends.php";

        JsonArrayRequest jsonArrayRequestSad = new JsonArrayRequest(Request.Method.GET, sadUrl, null, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {











                for (int s = 0; s < response.length(); s++) {
                    try {
                        JSONObject jsonObject = response.getJSONObject(s);

                        //StatusActivity.animationViewCatLoadss.setVisibility(View.GONE);
                        String con = jsonObject.getString("status");
                        String item = jsonObject.getString("item");

                        hashMap= new HashMap<>();
                        hashMap.put("item",item);
                        hashMap.put("status",con);
                        arrylistfriends.add(hashMap);
                        Log.d("helo", "attidte Arraylist receved and send now status activity: ");




                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }



                }










            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });

        RequestQueue queue = Volley.newRequestQueue(ManageServer.this);  // Use requireActivity() in Fragment
        queue.add(jsonArrayRequestSad);


















    }

    public void  Relationship(){









        String sadUrl = "https://appsallglabal.com/Statuswall/catgory%20php%20/relationship.php";

        JsonArrayRequest jsonArrayRequestSad = new JsonArrayRequest(Request.Method.GET, sadUrl, null, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {











                for (int s = 0; s < response.length(); s++) {
                    try {
                        JSONObject jsonObject = response.getJSONObject(s);

                        //StatusActivity.animationViewCatLoadss.setVisibility(View.GONE);
                        String con = jsonObject.getString("status");
                        String item = jsonObject.getString("item");

                        hashMap= new HashMap<>();
                        hashMap.put("item",item);
                        hashMap.put("status",con);
                        arraylistRelationship.add(hashMap);
                        Log.d("helo", "attidte Arraylist receved and send now status activity: ");




                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }



                }










            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });

        RequestQueue queue = Volley.newRequestQueue(ManageServer.this);  // Use requireActivity() in Fragment
        queue.add(jsonArrayRequestSad);


















    }


    public void  sad(){









        String sadUrl = "https://appsallglabal.com/Statuswall/catgory%20php%20/sad.php";

        JsonArrayRequest jsonArrayRequestSad = new JsonArrayRequest(Request.Method.GET, sadUrl, null, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {











                for (int s = 0; s < response.length(); s++) {
                    try {
                        JSONObject jsonObject = response.getJSONObject(s);

                        //StatusActivity.animationViewCatLoadss.setVisibility(View.GONE);
                        String con = jsonObject.getString("status");
                        String item = jsonObject.getString("item");

                        hashMap= new HashMap<>();
                        hashMap.put("item",item);
                        hashMap.put("status",con);
                        arraylistsad.add(hashMap);
                        Log.d("helo", "attidte Arraylist receved and send now status activity: ");




                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }



                }










            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });

        RequestQueue queue = Volley.newRequestQueue(ManageServer.this);  // Use requireActivity() in Fragment
        queue.add(jsonArrayRequestSad);


















    }

    public void  study(){









        String sadUrl = "https://appsallglabal.com/Statuswall/catgory%20php%20/study.php";

        JsonArrayRequest jsonArrayRequestSad = new JsonArrayRequest(Request.Method.GET, sadUrl, null, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {











                for (int s = 0; s < response.length(); s++) {
                    try {
                        JSONObject jsonObject = response.getJSONObject(s);

                        //StatusActivity.animationViewCatLoadss.setVisibility(View.GONE);
                        String con = jsonObject.getString("status");
                        String item = jsonObject.getString("item");

                        hashMap= new HashMap<>();
                        hashMap.put("item",item);
                        hashMap.put("status",con);
                        araylistStudy.add(hashMap);
                        Log.d("helo", "attidte Arraylist receved and send now status activity: ");




                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }



                }










            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });

        RequestQueue queue = Volley.newRequestQueue(ManageServer.this);  // Use requireActivity() in Fragment
        queue.add(jsonArrayRequestSad);


















    }




}

