package com.appsallglobal.statuswalls;



import static com.appsallglobal.statuswalls.MainActivity2.REQUEST_WRITE_STORAGE;

import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.text.Layout;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.cardview.widget.CardView;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import androidx.core.content.FileProvider;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.airbnb.lottie.BuildConfig;
import com.airbnb.lottie.LottieAnimationView;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.material.appbar.MaterialToolbar;
import com.squareup.picasso.Picasso;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Random;

public class StatusActiviy2 extends AppCompatActivity {
    MaterialToolbar materialToolbar;
    RecyclerView recyclerView;
public  static Layout layoutStatic = null;
  int coppyCount= 4;
 int downloadCount= 1;
    HashMap<String,String> hashMap;
 public  static    ArrayList<HashMap<String,String>> arrayListStatus = new ArrayList<>();
    private int[] imageList1 = {R.drawable.p1,  R.drawable.p3,R.drawable.p4,R.drawable.p6,R.drawable.tab6,R.drawable.tab5,R.drawable.tab4,R.drawable.tab3,R.drawable.tab2,R.drawable.tab1};
    String[] imageList = {
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab1.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab2.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab3.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab4.png",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab5.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab6.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab7.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab8.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab9.jpg",
            "https://appsallglabal.com/Statuswall/Random%20Image%20/tab10.jpg"
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        getWindow().setFlags(WindowManager.LayoutParams.FLAG_SECURE, WindowManager.LayoutParams.FLAG_SECURE);
        setContentView(R.layout.activity_status_activiy2);

        materialToolbar = findViewById(R.id.materialtolbarStatus);
recyclerView = findViewById(R.id.recyclerview);


materialToolbar.setTitle(StatusCatagorActivityy.toltitle);
        materialToolbar.setNavigationOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                // Handle the navigation icon click here




                finish();
                // Example: If you want to finish the activity on click
                // finish();
            }
        });


;



statusAdapter statusAdapter = new statusAdapter(arrayListStatus);
recyclerView.setAdapter(statusAdapter);
recyclerView.setLayoutManager(new LinearLayoutManager(StatusActiviy2.this));






    }



    private class statusAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

        int status_item = 0;
        int native_item = 1;
        ArrayList<HashMap<String, String>> arrayListStatus;

        public statusAdapter(ArrayList<HashMap<String, String>> arrayListStatus) {
            this.arrayListStatus = arrayListStatus;
        }

        private  class statusHolder extends RecyclerView.ViewHolder {
            LinearLayout coppyButton, shareButton;
            TextView textView;
            ImageView imageViewTab;
            RelativeLayout bodyDownload;
            LinearLayout savedButton;
     public CardView cardViewsFanai;

            public statusHolder(@NonNull View itemView) {
                super(itemView);
                textView = itemView.findViewById(R.id.sadStatusContent);
                coppyButton = itemView.findViewById(R.id.coppyButton);
                shareButton = itemView.findViewById(R.id.shareButton);
                imageViewTab = itemView.findViewById(R.id.imageViewTab);
                bodyDownload = itemView.findViewById(R.id.bodyDownload);
                cardViewsFanai=itemView.findViewById(R.id.cardViewSFainal);
                savedButton = itemView.findViewById(R.id.savedButton);
            }
        }

        private class nativeHolder extends RecyclerView.ViewHolder {
            public nativeHolder(@NonNull View itemView) {
                super(itemView);
            }
        }

        @NonNull
        @Override
        public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
            LayoutInflater layoutInflater = LayoutInflater.from(parent.getContext());

            if (viewType == status_item) {
                View sView = layoutInflater.inflate(R.layout.status_item2, parent, false);
                return new statusHolder(sView);
            } else {
                View nView = layoutInflater.inflate(R.layout.naive_item, parent, false); // native_item_layout টি আপনি কাস্টম লেআউট হিসেবে তৈরি করবেন
                return new nativeHolder(nView);
            }
        }

        @Override
        public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
            if (getItemViewType(position) == status_item) {
                statusHolder statusHolder = (statusHolder) holder;
                HashMap<String, String> hashMap = arrayListStatus.get(position);

                if (hashMap != null && !hashMap.isEmpty()) {
                    String content = hashMap.get("status");

                    statusHolder.textView.setText(content);
                    Log.d("helo", "succes to me: ");
                    // Button এর জন্য OnClickListener
// Button এ ক্লিক ইভেন্ট সেট করা হলো




                    statusHolder.savedButton.setOnClickListener(v -> {

                        if (ContextCompat.checkSelfPermission(StatusActiviy2.this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE)
                                != PackageManager.PERMISSION_GRANTED) {
                            // Request permission
                            ActivityCompat.requestPermissions(StatusActiviy2.this,
                                    new String[]{android.Manifest.permission.WRITE_EXTERNAL_STORAGE}, REQUEST_WRITE_STORAGE);
                        } else {
                            // Permission granted, start saving the image
                            try {
                                downloadCount++;

                                // Create Bitmap from layout
                                Bitmap bitmap = Bitmap.createBitmap(statusHolder.bodyDownload.getWidth(),
                                        statusHolder.bodyDownload.getHeight(), Bitmap.Config.ARGB_8888);
                                Canvas canvas = new Canvas(bitmap);
                                statusHolder.bodyDownload.draw(canvas);

                                if (bitmap == null) {
                                    Toast.makeText(StatusActiviy2.this, "Failed to create bitmap!", Toast.LENGTH_SHORT).show();
                                    Log.e("Bitmap Error", "Bitmap is null.");
                                    return;
                                }

                                OutputStream fos;
                                String fileName = "Simple_image_" + System.currentTimeMillis() + ".jpg"; // Unique file name

                                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.Q) {
                                    // For Android 10 and above
                                    ContentResolver resolver = getContentResolver();
                                    ContentValues contentValues = new ContentValues();
                                    contentValues.put(MediaStore.MediaColumns.DISPLAY_NAME, fileName);
                                    contentValues.put(MediaStore.MediaColumns.MIME_TYPE, "image/jpeg");
                                    contentValues.put(MediaStore.MediaColumns.RELATIVE_PATH, Environment.DIRECTORY_PICTURES);

                                    Uri imageUri = resolver.insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, contentValues);
                                    if (imageUri != null) {
                                        fos = resolver.openOutputStream(imageUri);
                                    } else {
                                        throw new IOException("Failed to create new MediaStore record.");
                                    }
                                } else {
                                    // For Android 9 and below
                                    String root = Environment.getExternalStorageDirectory().getAbsolutePath();
                                    File file = new File(root + "/Pictures");
                                    if (!file.exists()) {
                                        file.mkdirs();
                                    }

                                    File myFile = new File(file, fileName);
                                    fos = new FileOutputStream(myFile);
                                }

                                // Save Bitmap
                                bitmap.compress(Bitmap.CompressFormat.JPEG, 100, fos);
                                fos.flush();
                                fos.close();

                                Toast.makeText(StatusActiviy2.this, "Saved Image", Toast.LENGTH_SHORT).show();
                                Log.d("Save Status", "Bitmap saved successfully.");

                                if (downloadCount % 2 == 0) {
                                    showHomepageADD();
                                }

                            } catch (IOException e) {
                                e.printStackTrace();
                                Toast.makeText(StatusActiviy2.this, "Error saving image: " + e.getMessage(), Toast.LENGTH_LONG).show();
                                Log.e("Save Error", "Error in FileOutputStream: " + e.getMessage());
                            }
                        }
                    });




                    statusHolder.coppyButton.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            coppyCount++;
                            String myText = statusHolder.textView.getText().toString();
                            if (!myText.isEmpty()) {
                                ClipboardManager clipboard = (ClipboardManager) getSystemService(Context.CLIPBOARD_SERVICE);
                                ClipData clip = ClipData.newPlainText("Copied Text", myText);
                                clipboard.setPrimaryClip(clip);
                                Toast.makeText(StatusActiviy2.this, "Text Copied", Toast.LENGTH_SHORT).show();
                                if (coppyCount%5==0){
showHomepageADD();

                                }
                            } else {
                                Toast.makeText(StatusActiviy2.this, "Something is wrong", Toast.LENGTH_SHORT).show();
                            }
                        }
                    });

                    statusHolder.shareButton.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            if (!content.isEmpty()) {
                                shareText(content);
                            }
                        }
                    });

                    Random random = new Random();
                    int randomIndex = random.nextInt(imageList1.length);
statusHolder.imageViewTab.setImageResource(imageList1[randomIndex]);
                    statusHolder.imageViewTab.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            Random random = new Random();
                            int randomIndex = random.nextInt(imageList1.length);
                            statusHolder.imageViewTab.setImageResource(imageList1[randomIndex]);
                        }
                    });








                } else {
                    Toast.makeText(StatusActiviy2.this, "Data not received", Toast.LENGTH_SHORT).show();
                }
            }
        }

        @Override
        public int getItemCount() {
            return arrayListStatus.size();
        }

        @Override
        public int getItemViewType(int position) {
            HashMap<String, String> hashMap = arrayListStatus.get(position);
            String item = hashMap != null ? hashMap.get("item") : null;
            if (item != null && item.contains("status")) return status_item;
            else return native_item;
        }
    }
















    private void shareText(String text) {
        Intent sendIntent = new Intent();
        sendIntent.setAction(Intent.ACTION_SEND);
        sendIntent.putExtra(Intent.EXTRA_TEXT, text);
        sendIntent.setType("text/plain");

        Intent shareIntent = Intent.createChooser(sendIntent, null);
        startActivity(shareIntent);
    }



    private void   showHomepageADD( ) {

        String url = "https://appsallglabal.com/Statuswall/Admob%20Ads%20Control/fullscreenads.php";
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url, new Response.Listener<String>() {
            @Override
            public void onResponse(String response) {

                if (response.contains("on")){

                    if (ManageServer.mInterstitialAd != null) {
                        ManageServer.mInterstitialAd.show(StatusActiviy2.this);
                    } else {
                        Log.d("TAG", "The interstitial ad wasn't ready yet.");
                    }

                }






            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });
        RequestQueue queue = Volley.newRequestQueue(StatusActiviy2.this);

// Add the request to the queue
        queue.add(stringRequest);

    }







}